<?php
/*
Plugin Name: Flash MP3 Player Widget
Plugin URI: http://www.charlestang.cn/flash-player-widget.htm
Description: 一个flash写的MP3播放器（作者不详），这是WordPress Widget版本，免去处理代码的烦恼，可以后台设置播放列表，10首。
Version: 8.8.11
Author: Charles Tang
Author URI: http://www.charlestang.cn
*/

/*  
	Copyright 2008  Charles Tang  (email : tngchao@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

function widget_flash_mp3player_init() {
	if (!function_exists('register_sidebar_widget')) {
		return;
	}

	function widget_flash_mp3player($args) {
		extract($args);
		$options = get_option('widget_flash_mp3player');
		$title = htmlspecialchars(stripslashes($options['title']));	
		echo $before_widget.$before_title.$title.$after_title;
		echo '<ul><li class="flash_player_widget">'."\n";
		$base_name = WP_CONTENT_URL . '/plugins/flash-mp3-player';
		$datafield = $base_name . '/mp3player.swf?playlist=' . $base_name . '/playlist.xml';
		$valuefield = $datafield;
		$width = $options['width'];
		$height = $options['height'];
		?>

<object type="application/x-shockwave-flash" data="<?php echo $datafield;?>"  width="<?php echo $width;?>" height="<?php echo $height;?>" wmode="transparent">
<param name="movie" value="<?php echo $datafield;?>" />
<param name="wmode" value="transparent" />
</object>

  		<?php
		echo '</li></ul>'."\n";
		echo $after_widget;
	}

	function widget_flash_mp3player_options() {
		$options = get_option('widget_flash_mp3player');
		if (!is_array($options)) {
			$options = array('title' => __('Flash MP3 Player','fmp'), 'width' => 177, 'height' => 280);
		}
		if ($_POST['fmp-submit']) {
			$options['title'] = strip_tags($_POST['fmp-title']);
			$options['width'] = intval($_POST['fmp-width']);
			$options['height'] = intval($_POST['fmp-height']);
			update_option('widget_flash_mp3player', $options);
		}
		echo '<p style="text-align: left;"><label for="fmp-title">';
		_e('Title: ','fmp');
		echo '</label><input type="text" id="fmp-title" name="fmp-title" value="'.htmlspecialchars(stripslashes($options['title'])).'" /></p>'."\n";
		echo '<p style="text-align: left;"><label for="fmp-width">';
		_e('Width: ','fmp');
		echo '</label><input type="text" id="fmp-width" name="fmp-width" value="'.intval($options['width']).'" size="3" /></p>'."\n";
		echo '<p style="text-align: left;"><label for="fmp-height">';
		_e('Height: ','fmp');
		echo '</label><input type="text" id="fmp-height" name="fmp-height" value="'.intval($options['height']).'" size="3" /></p>'."\n";
		echo '<input type="hidden" id="fmp-submit" name="fmp-submit" value="1" />'."\n";
	}
	
	$widget_ops =  array('classname' => 'widget_flash_mp3player', 'description' => __( 'Display a flash made MP3 Player.', 'fmp'));
	// Register Widgets
	wp_register_sidebar_widget('flash_mp3player', __('MP3 Player','fmp'), 'widget_flash_mp3player', $widget_ops);
	wp_register_widget_control('flash_mp3player', __('MP3 Player','fmp'), 'widget_flash_mp3player_options', 400, 200);
}

add_action('plugins_loaded','widget_flash_mp3player_init');

if(is_admin())
{
	add_action('init',  'fmp_initRoles');
	add_action('admin_menu', 'fmp_adminMenu');
	add_action('admin_notices', 'fmp_displayMessage');
}

function fmp_initRoles()
{
	if ( function_exists('get_role') ) {
		$role = get_role('administrator');
		if( $role != null && !$role->has_cap('admin_fmp') ) {
			$role->add_cap('admin_fmp');
		}
		// Clean var
		unset($role);
	}
}

function fmp_adminMenu()
{
	add_options_page( __('MP3: Play List', 'fmp'), __('MP3 Player', 'fmp'), 'admin_fmp', 'fmp_options', 'fmp_pageOptions');
}

function load_now_list_in(&$properties, &$songs)
{
	global $fmp_message, $fmp_status;
	$songs = array();
	$properties = array();
	$playlistfile = dirname(__FILE__) . '/playlist.xml';
	//var_dump($playlistfile);
	
	$playlistdom = new DOMDocument('1.0','utf-8');
	if (!$playlistdom->loadXML(file_get_contents($playlistfile))) 
	{
		echo "Error";
		//今后在这里添加错误提示信息
		return;
	}
	$items = $playlistdom->getElementsByTagName('player');
	foreach ($items as $item)
	{
		$properties['showDisplay'] = $item->getAttribute('showDisplay');
		$properties['showPlaylist'] = $item->getAttribute('showPlaylist');
		$properties['autoStart'] = $item->getAttribute('autoStart');
	}
	$items = $playlistdom->getElementsByTagName('song');
	foreach ($items as $item)
	{
		$songs[]=array('title' => $item->getAttribute('title'), 'path' => $item->getAttribute('path'));
	}
}
$fmp_message = '';
$fmp_status ='';
function fmp_pageOptions()
{
	global $fmp_message, $fmp_status;
	$fmp_dirname = dirname(__FILE__);
	$fmp_admin_base_url = get_option('siteurl') . '/wp-admin/admin.php?page=';
	load_now_list_in($properties, $songs);
	
	// Update or reset options
	if ( isset($_POST['updateoptions']) ) {
		$songs = array();
		unset($songs);
		$songs = array();
		for($k = 0; $k < 10; $k++){
			if($_POST["song-title-$k"] != '' && $_POST["song-path-$k"] != '')
			{
				$songs[] = array('title'=>$_POST["song-title-$k"],'path'=>$_POST["song-path-$k"]);
			}
		}
		$properties['showDisplay'] = $_POST['fmp-show-dispay'];
		$properties['showPlaylist'] = $_POST['fmp-show-playlist'];
		$properties['autoStart'] = $_POST['fmp-auto-play'];

		$listfile = fopen($fmp_dirname . '/playlist.xml','w');

		$listdoc = new DOMDocument('1.0','UTF-8');
		$listroot = $listdoc->createElement('player');
		$listroot = $listdoc->appendChild($listroot);
		$listroot->setAttributeNode($listdoc->createAttribute('showDisplay'));
		$listroot->setAttribute('showDisplay',$properties['showDisplay']);
		$listroot->setAttributeNode($listdoc->createAttribute('showPlaylist'));
		$listroot->setAttribute('showPlaylist',$properties['showPlaylist']);
		$listroot->setAttributeNode($listdoc->createAttribute('autoStart'));
		$listroot->setAttribute('autoStart',$properties['autoStart']);
		foreach ( $songs as $song)
		{
			$songnode = $listdoc->createElement('song');
			$songnode->setAttributeNode($listdoc->createAttribute('title'));
			$songnode->setAttribute('title',$song['title']);
			$songnode->setAttributeNode($listdoc->createAttribute('path'));
			$songnode->setAttribute('path',$song['path']);
			$songnode = $listroot->appendChild($songnode);
		}
		fwrite($listfile, $listdoc->SaveXML());
		fclose($listfile);

		$fmp_message = __('Options saved', 'fmp');
		$fmp_status = 'updated';
	}
	fmp_displayMessage();
	$rows = count($songs);
	$left = 10 - $rows;
	$i=0;
	?>
	<div class="wrap">
	<h2><?php _e('MP3 Player','fmp'); ?></h2>
	<p><?php _e('Visit the <a href="http://www.charlestang.cn/flash-player-widget.htm">plugin\'s homepage</a> for further details. If you find a bug, or have a fantastic idea for this plugin, <a href="mailto:charlestang@foxmail.com">ask me</a> !', 'fmp'); ?></p>
	<form method="post" action="<?php echo $fmp_admin_base_url . 'fmp_options';?>">
		<table class="form-table">
		<tbody>
			<tr>
				<th scope="row"><?php _e('Player Properties','fmp'); ?></th>
				<td><fieldset>
					<legend class="hidden"><?php _e('Player Properties','fmp'); ?></legend>
					<p><label for="fmp-show-dispay"><?php _e('Show upper panel, yes or no?&nbsp;&nbsp;','fmp'); ?><input type="text" id="fmp-show-dispay" name="fmp-show-dispay" value="<?php echo $properties['showDisplay'];?>" size="5"/></label></p>
					<p><label for="fmp-show-playlist"><?php _e('Show play list, yes or no?&nbsp;&nbsp;','fmp'); ?><input type="text" id="fmp-show-playlist" name="fmp-show-playlist" value="<?php echo $properties['showPlaylist'];?>" size="5"/></label></p>
					<p><label for="fmp-auto-play"><?php _e('Auto start, yes or no?&nbsp;&nbsp;','fmp'); ?><input type="text" id="fmp-auto-play" name="fmp-auto-play" value="<?php echo $properties['autoStart'];?>" size="5"/></label></p>
				</fieldset></td>
			</tr>
			<tr>
				<th scope="row"><?php _e('Songs List','fmp'); ?></th>
				<td><fieldset>
					<legend class="hidden"><?php _e('Songs List','fmp'); ?></legend>
		<?php foreach($songs as $song) { ?>
					<p>
						<label for="song-<?php echo $i;?>">
						<?php echo $i;?><?php _e('Title:','fmp');?>
						<input type="text" name="song-title-<?php echo $i;?>" id="song-title-<?php echo $i;?>" value="<?php echo $song['title']; ?>" size="15"/>
						<?php _e('URL:','fmp');?>
						<input type="text" name="song-path-<?php echo $i;?>" id="song-path-<?php echo $i;?>" value="<?php echo $song['path']; ?>" size="75"/>
						</label>
					</p>
					<?php $i++;?>
		<?php } ?>
		<?php for($j = 0; $j < $left; $j++) { ?>
					<p>
						<label for="song-<?php echo $i;?>">
						<?php echo $i;?><?php _e('Title:','fmp');?>
						<input type="text" name="song-title-<?php echo $i;?>" id="song-title-<?php echo $i;?>" value="" size="15"/>
						<?php _e('URL:','fmp');?>
						<input type="text" name="song-path-<?php echo $i;?>" id="song-path-<?php echo $i;?>" value="" size="75"/>
						</label>
					</p>
					<?php $i++;?>
		<?php } ?>
					</fieldset></td>
			</tr>

		</tbody>
		</table>
		<input type="hidden" name="action" value="update" />			
		<p class="submit">
			<input type="submit" name="updateoptions" value="<?php _e('Save Changes') ?>" />
		</p>
	</form>
	<?php fmp_printAdminFooter(); ?>
	</div><!--/wrap-->
	<?php
}

############## Admin WP Helper ##############
/**
 * Display plugin Copyright
 *
 */
function fmp_printAdminFooter() {
	?>
	<p class="footer_st" style="font-size:0.8em;text-align:center;"><?php printf(__('&copy; Copyright 2008 <a href="http://www.charlestang.cn/" title="Here With Me">Charles Tang</a> | <a href="http://www.charlestang.cn/flash-mp3-player.htm">Flash MP3 Player</a> | Version %s', 'fmp'), '8.8.7'); ?></p>
	<?php
} 

/**
 * Display WP alert
 *
 */
function fmp_displayMessage() {
	global $fmp_message, $fmp_status;
	if ( $mess != '') {
		$message = $fmp_message;
		$status = $fmp_status;
		$fmp_message = $fmp_status = ''; // Reset
	}

	if ( $message ) {
	?>
		<div id="message" class="<?php echo ($status != '') ? $status :'updated'; ?> fade">
			<p><strong><?php echo $message; ?></strong></p>
		</div>
	<?php
	}
}

?>